//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class ContactsApi {
  ContactsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Get Contacts search
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ContactList</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] term (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<Response> contactsSearchWithHttpInfo(String term, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (term == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: term');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Contacts/Search(Term={term})"
      .replaceAll('{term}', term)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Contacts search
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ContactList</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] term (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<ContactList> contactsSearch(String term, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await contactsSearchWithHttpInfo(term, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ContactList',) as ContactList;
    
    }
    return Future<ContactList>.value();
  }

  /// Get Contacts 
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ContactList</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<Response> getContactsWithHttpInfo(String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Contacts"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Contacts 
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ContactList</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<ContactList> getContacts(String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await getContactsWithHttpInfo(region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ContactList',) as ContactList;
    
    }
    return Future<ContactList>.value();
  }
}
