//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class ConversationsApi {
  ConversationsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Aggregates conversation data efficiently for reporting purposes
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Aggregates conversation data efficiently for reporting purposes.<br/>Return Type: <b>AggregateListValue</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [bool] dollarCount:
  ///
  /// * [String] field:
  ///   The field to aggregate on
  Future<Response> aggregateDataWithHttpInfo(String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, bool dollarCount, String field, }) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/Aggregate()"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }
    if (field != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'field', field));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Aggregates conversation data efficiently for reporting purposes
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Aggregates conversation data efficiently for reporting purposes.<br/>Return Type: <b>AggregateListValue</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [bool] dollarCount:
  ///
  /// * [String] field:
  ///   The field to aggregate on
  Future<AggregateListValue> aggregateData(String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, bool dollarCount, String field, }) async {
    final response = await aggregateDataWithHttpInfo(region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarCount: dollarCount, field: field, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AggregateListValue',) as AggregateListValue;
    
    }
    return Future<AggregateListValue>.value();
  }

  /// Get Conversations clone conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Int32Value</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> cloneConversationWithHttpInfo(int key, String region,) async {
    // Verify required params are set.
    if (key == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: key');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/{key}/Clone"
      .replaceAll('{key}', key.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations clone conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Int32Value</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Int32Value> cloneConversation(int key, String region,) async {
    final response = await cloneConversationWithHttpInfo(key, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Int32Value',) as Int32Value;
    
    }
    return Future<Int32Value>.value();
  }

  /// Delete Conversations conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> deleteConversationWithHttpInfo(int key, String region,) async {
    // Verify required params are set.
    if (key == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: key');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/{key}"
      .replaceAll('{key}', key.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Delete Conversations conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> deleteConversation(int key, String region,) async {
    final response = await deleteConversationWithHttpInfo(key, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Delete Conversations file
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [int] fileId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> deleteFileWithHttpInfo(int conversationId, int id, int fileId, String region,) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (fileId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: fileId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Files({fileId})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{fileId}', fileId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Delete Conversations file
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [int] fileId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> deleteFile(int conversationId, int id, int fileId, String region,) async {
    final response = await deleteFileWithHttpInfo(conversationId, id, fileId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Delete Conversations message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> deleteMessageWithHttpInfo(int conversationId, int id, String region,) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Delete Conversations message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> deleteMessage(int conversationId, int id, String region,) async {
    final response = await deleteMessageWithHttpInfo(conversationId, id, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Delete Conversations message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] index:
  ///
  /// * [String] ref:
  Future<Response> deleteMessagePartWithHttpInfo(int conversationId, int id, String region, { int index, String ref, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Delete"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (index != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'index', index));
    }
    if (ref != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'ref', ref));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Delete Conversations message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] index:
  ///
  /// * [String] ref:
  Future<void> deleteMessagePart(int conversationId, int id, String region, { int index, String ref, }) async {
    final response = await deleteMessagePartWithHttpInfo(conversationId, id, region,  index: index, ref: ref, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Delete Conversations participant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> deleteParticipantWithHttpInfo(int conversationId, int id, String region,) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Participants({id})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Delete Conversations participant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> deleteParticipant(int conversationId, int id, String region,) async {
    final response = await deleteParticipantWithHttpInfo(conversationId, id, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Get Conversations 
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ConversationList</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<Response> getConversationsWithHttpInfo(String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations 
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ConversationList</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<ConversationList> getConversations(String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await getConversationsWithHttpInfo(region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ConversationList',) as ConversationList;
    
    }
    return Future<ConversationList>.value();
  }

  /// Get Conversations by id
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Conversation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarSelect:
  Future<Response> getConversationsByIdWithHttpInfo(int key, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (key == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: key');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/{key}"
      .replaceAll('{key}', key.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations by id
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Conversation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarSelect:
  Future<Conversation> getConversationsById(int key, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await getConversationsByIdWithHttpInfo(key, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Conversation',) as Conversation;
    
    }
    return Future<Conversation>.value();
  }

  /// Get Conversations demo conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ConversationTenant</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] original:
  ///
  /// * [bool] asOwner:
  Future<Response> getDemoConversationWithHttpInfo(String region, { int original, bool asOwner, }) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/Demo"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (original != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'original', original));
    }
    if (asOwner != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'asOwner', asOwner));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations demo conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ConversationTenant</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] original:
  ///
  /// * [bool] asOwner:
  Future<ConversationTenant> getDemoConversation(String region, { int original, bool asOwner, }) async {
    final response = await getDemoConversationWithHttpInfo(region,  original: original, asOwner: asOwner, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ConversationTenant',) as ConversationTenant;
    
    }
    return Future<ConversationTenant>.value();
  }

  /// Get Conversations file
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [int] fileId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] size:
  Future<Response> getFileWithHttpInfo(int conversationId, int id, int fileId, String region, { String size, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (fileId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: fileId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Files({fileId})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{fileId}', fileId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (size != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'size', size));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations file
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [int] fileId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] size:
  Future<MultipartFile> getFile(int conversationId, int id, int fileId, String region, { String size, }) async {
    final response = await getFileWithHttpInfo(conversationId, id, fileId, region,  size: size, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Get Conversations files
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Blob</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<Response> getFilesWithHttpInfo(int conversationId, int id, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Files"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations files
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Blob</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<List<Blob>> getFiles(int conversationId, int id, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await getFilesWithHttpInfo(conversationId, id, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<Blob>') as List)
        .cast<Blob>()
        .toList(growable: false);

    }
    return Future<List<Blob>>.value();
  }

  /// Get Conversations message by id
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Message</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarSelect:
  Future<Response> getMessageByIdWithHttpInfo(int conversationId, int id, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations message by id
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Message</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarSelect:
  Future<Message> getMessageById(int conversationId, int id, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await getMessageByIdWithHttpInfo(conversationId, id, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Message',) as Message;
    
    }
    return Future<Message>.value();
  }

  /// Get Conversations messages
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>MessageList</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<Response> getMessagesWithHttpInfo(int conversationId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations messages
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>MessageList</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<MessageList> getMessages(int conversationId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await getMessagesWithHttpInfo(conversationId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MessageList',) as MessageList;
    
    }
    return Future<MessageList>.value();
  }

  /// Get Conversations participiants
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ParticipantWithRoleList</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<Response> getParticipiantsWithHttpInfo(int conversationId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Participants"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations participiants
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ParticipantWithRoleList</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///
  /// * [String] dollarFilter:
  ///
  /// * [String] dollarSelect:
  ///
  /// * [String] dollarOrderby:
  ///
  /// * [int] dollarTop:
  ///
  /// * [int] dollarSkip:
  ///
  /// * [bool] dollarCount:
  Future<ParticipantWithRoleList> getParticipiants(int conversationId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await getParticipiantsWithHttpInfo(conversationId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ParticipantWithRoleList',) as ParticipantWithRoleList;
    
    }
    return Future<ParticipantWithRoleList>.value();
  }

  /// Imports a BCF File's Topics and Markup as one or more Flex conversations
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Imports a BCF File's Topics and Markup as one or more Flex conversations.<br/>Return Type: <b>ConversationList</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   An arbitrary file which will get associated to the message.
  ///
  /// * [String] tenantId:
  ///   Either the tenant identifier string or GUID
  ///
  /// * [int] assetId:
  ///   An optional AssetId to help identify the asset hosting the referenced model
  ///
  /// * [int] modelId:
  ///   An optional ModelId identifying the model to link the BCF to
  ///
  /// * [String] fileName:
  ///   The name of the file
  Future<Response> importBcfFileWithHttpInfo(String region, MultipartFile file, { String tenantId, int assetId, int modelId, String fileName, }) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (file == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: file');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/ImportBcf"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (tenantId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'tenantId', tenantId));
    }
    if (assetId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
    }
    if (modelId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['multipart/form-data'];

    bool hasFields = false;
    final mp = MultipartRequest('POST', Uri.parse(path));
    if (file != null) {
      hasFields = true;
      mp.fields[r'file'] = file.field;
      mp.files.add(file);
    }
    if (fileName != null) {
      hasFields = true;
      mp.fields[r'fileName'] = parameterToString(fileName);
    }
    if (hasFields) {
      postBody = mp;
    }

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Imports a BCF File's Topics and Markup as one or more Flex conversations
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Imports a BCF File's Topics and Markup as one or more Flex conversations.<br/>Return Type: <b>ConversationList</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   An arbitrary file which will get associated to the message.
  ///
  /// * [String] tenantId:
  ///   Either the tenant identifier string or GUID
  ///
  /// * [int] assetId:
  ///   An optional AssetId to help identify the asset hosting the referenced model
  ///
  /// * [int] modelId:
  ///   An optional ModelId identifying the model to link the BCF to
  ///
  /// * [String] fileName:
  ///   The name of the file
  Future<ConversationList> importBcfFile(String region, MultipartFile file, { String tenantId, int assetId, int modelId, String fileName, }) async {
    final response = await importBcfFileWithHttpInfo(region, file,  tenantId: tenantId, assetId: assetId, modelId: modelId, fileName: fileName, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ConversationList',) as ConversationList;
    
    }
    return Future<ConversationList>.value();
  }

  /// Post Conversations insert message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] index:
  ///
  /// * [MessagePart] messagePart:
  Future<Response> insertMessagePartWithHttpInfo(int conversationId, int id, String region, { int index, MessagePart messagePart, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Insert"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = messagePart;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (index != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'index', index));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations insert message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] index:
  ///
  /// * [MessagePart] messagePart:
  Future<void> insertMessagePart(int conversationId, int id, String region, { int index, MessagePart messagePart, }) async {
    final response = await insertMessagePartWithHttpInfo(conversationId, id, region,  index: index, messagePart: messagePart, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Post Conversations mode message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] previousIndex:
  ///
  /// * [int] currentIndex:
  Future<Response> modeMessagePartWithHttpInfo(int conversationId, int id, String region, { int previousIndex, int currentIndex, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Move"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (previousIndex != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'previousIndex', previousIndex));
    }
    if (currentIndex != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'currentIndex', currentIndex));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations mode message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] previousIndex:
  ///
  /// * [int] currentIndex:
  Future<void> modeMessagePart(int conversationId, int id, String region, { int previousIndex, int currentIndex, }) async {
    final response = await modeMessagePartWithHttpInfo(conversationId, id, region,  previousIndex: previousIndex, currentIndex: currentIndex, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Patch Conversations conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ConversationUpdate] conversationUpdate:
  Future<Response> patchConversationWithHttpInfo(int key, String region, { ConversationUpdate conversationUpdate, }) async {
    // Verify required params are set.
    if (key == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: key');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/{key}"
      .replaceAll('{key}', key.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = conversationUpdate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Patch Conversations conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ConversationUpdate] conversationUpdate:
  Future<void> patchConversation(int key, String region, { ConversationUpdate conversationUpdate, }) async {
    final response = await patchConversationWithHttpInfo(key, region,  conversationUpdate: conversationUpdate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Patch Conversations message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Message</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MessageUpdate] messageUpdate:
  Future<Response> patchMessageWithHttpInfo(int conversationId, int id, String region, { MessageUpdate messageUpdate, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = messageUpdate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Patch Conversations message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Message</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MessageUpdate] messageUpdate:
  Future<Message> patchMessage(int conversationId, int id, String region, { MessageUpdate messageUpdate, }) async {
    final response = await patchMessageWithHttpInfo(conversationId, id, region,  messageUpdate: messageUpdate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Message',) as Message;
    
    }
    return Future<Message>.value();
  }

  /// Patch Conversations participant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ParticipantWithRoleUpdate] participantWithRoleUpdate:
  Future<Response> patchParticipantWithHttpInfo(int conversationId, int id, String region, { ParticipantWithRoleUpdate participantWithRoleUpdate, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Participants({id})"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = participantWithRoleUpdate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Patch Conversations participant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ParticipantWithRoleUpdate] participantWithRoleUpdate:
  Future<void> patchParticipant(int conversationId, int id, String region, { ParticipantWithRoleUpdate participantWithRoleUpdate, }) async {
    final response = await patchParticipantWithHttpInfo(conversationId, id, region,  participantWithRoleUpdate: participantWithRoleUpdate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Post Conversations conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Conversation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ConversationCreate] conversationCreate:
  Future<Response> postConversationWithHttpInfo(String region, { ConversationCreate conversationCreate, }) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = conversationCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Conversation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ConversationCreate] conversationCreate:
  Future<Conversation> postConversation(String region, { ConversationCreate conversationCreate, }) async {
    final response = await postConversationWithHttpInfo(region,  conversationCreate: conversationCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Conversation',) as Conversation;
    
    }
    return Future<Conversation>.value();
  }

  /// Post Conversations file
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Blob</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   An arbitrary file which will get associated to the message.
  ///
  /// * [int] partIndex:
  ///
  /// * [String] ref:
  ///
  /// * [String] fileName:
  ///   The name of the file
  Future<Response> postFileWithHttpInfo(int conversationId, int id, String region, MultipartFile file, { int partIndex, String ref, String fileName, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (file == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: file');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Files"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (partIndex != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'partIndex', partIndex));
    }
    if (ref != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'ref', ref));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['multipart/form-data'];

    bool hasFields = false;
    final mp = MultipartRequest('POST', Uri.parse(path));
    if (file != null) {
      hasFields = true;
      mp.fields[r'file'] = file.field;
      mp.files.add(file);
    }
    if (fileName != null) {
      hasFields = true;
      mp.fields[r'fileName'] = parameterToString(fileName);
    }
    if (hasFields) {
      postBody = mp;
    }

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations file
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Blob</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   An arbitrary file which will get associated to the message.
  ///
  /// * [int] partIndex:
  ///
  /// * [String] ref:
  ///
  /// * [String] fileName:
  ///   The name of the file
  Future<Blob> postFile(int conversationId, int id, String region, MultipartFile file, { int partIndex, String ref, String fileName, }) async {
    final response = await postFileWithHttpInfo(conversationId, id, region, file,  partIndex: partIndex, ref: ref, fileName: fileName, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Blob',) as Blob;
    
    }
    return Future<Blob>.value();
  }

  /// Post Conversations message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Message</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MessageCreate] messageCreate:
  Future<Response> postMessageWithHttpInfo(int conversationId, String region, { MessageCreate messageCreate, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = messageCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Message</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MessageCreate] messageCreate:
  Future<Message> postMessage(int conversationId, String region, { MessageCreate messageCreate, }) async {
    final response = await postMessageWithHttpInfo(conversationId, region,  messageCreate: messageCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Message',) as Message;
    
    }
    return Future<Message>.value();
  }

  /// Post Conversations participant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ParticipantWithRole</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ParticipantWithRoleCreate] participantWithRoleCreate:
  Future<Response> postParticipantWithHttpInfo(int conversationId, String region, { ParticipantWithRoleCreate participantWithRoleCreate, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Participants"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = participantWithRoleCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations participant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ParticipantWithRole</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ParticipantWithRoleCreate] participantWithRoleCreate:
  Future<ParticipantWithRole> postParticipant(int conversationId, String region, { ParticipantWithRoleCreate participantWithRoleCreate, }) async {
    final response = await postParticipantWithHttpInfo(conversationId, region,  participantWithRoleCreate: participantWithRoleCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ParticipantWithRole',) as ParticipantWithRole;
    
    }
    return Future<ParticipantWithRole>.value();
  }

  /// Put Conversations message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] index:
  ///
  /// * [String] ref:
  ///
  /// * [MessagePart] messagePart:
  Future<Response> putMessagePartWithHttpInfo(int conversationId, int id, String region, { int index, String ref, MessagePart messagePart, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Set"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = messagePart;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (index != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'index', index));
    }
    if (ref != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'ref', ref));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Put Conversations message part
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] index:
  ///
  /// * [String] ref:
  ///
  /// * [MessagePart] messagePart:
  Future<void> putMessagePart(int conversationId, int id, String region, { int index, String ref, MessagePart messagePart, }) async {
    final response = await putMessagePartWithHttpInfo(conversationId, id, region,  index: index, ref: ref, messagePart: messagePart, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Put Conversations participants
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [List<ParticipantWithRoleCreate>] participantWithRoleCreate:
  Future<Response> putParticipantsWithHttpInfo(int conversationId, String region, { List<ParticipantWithRoleCreate> participantWithRoleCreate, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Participants"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = participantWithRoleCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Put Conversations participants
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [List<ParticipantWithRoleCreate>] participantWithRoleCreate:
  Future<void> putParticipants(int conversationId, String region, { List<ParticipantWithRoleCreate> participantWithRoleCreate, }) async {
    final response = await putParticipantsWithHttpInfo(conversationId, region,  participantWithRoleCreate: participantWithRoleCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Get Conversations send clone conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>BooleanValue</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] email:
  Future<Response> sendCloneConversationWithHttpInfo(int key, String region, { String email, }) async {
    // Verify required params are set.
    if (key == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: key');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations/{key}/SendClone"
      .replaceAll('{key}', key.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (email != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'email', email));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Conversations send clone conversation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>BooleanValue</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] email:
  Future<BooleanValue> sendCloneConversation(int key, String region, { String email, }) async {
    final response = await sendCloneConversationWithHttpInfo(key, region,  email: email, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BooleanValue',) as BooleanValue;
    
    }
    return Future<BooleanValue>.value();
  }

  /// Post Conversations send message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> sendMessageWithHttpInfo(int conversationId, int id, String region,) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Send"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations send message
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> sendMessage(int conversationId, int id, String region,) async {
    final response = await sendMessageWithHttpInfo(conversationId, id, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Put Conversations set message state
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] state:
  Future<Response> setMessageStateWithHttpInfo(int conversationId, int id, String region, { String state, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/SetState"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (state != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'state', state));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Put Conversations set message state
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] state:
  Future<void> setMessageState(int conversationId, int id, String region, { String state, }) async {
    final response = await setMessageStateWithHttpInfo(conversationId, id, region,  state: state, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Post Conversations swap message parts
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] indexA:
  ///
  /// * [int] indexB:
  Future<Response> swapMessagePartsWithHttpInfo(int conversationId, int id, String region, { int indexA, int indexB, }) async {
    // Verify required params are set.
    if (conversationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: conversationId');
    }
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/comms/2.0/Conversations({conversationId})/Messages({id})/Swap"
      .replaceAll('{conversationId}', conversationId.toString())
      .replaceAll('{id}', id.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (indexA != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'indexA', indexA));
    }
    if (indexB != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'indexB', indexB));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Conversations swap message parts
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] conversationId (required):
  ///
  /// * [int] id (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [int] indexA:
  ///
  /// * [int] indexB:
  Future<void> swapMessageParts(int conversationId, int id, String region, { int indexA, int indexB, }) async {
    final response = await swapMessagePartsWithHttpInfo(conversationId, id, region,  indexA: indexA, indexB: indexB, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }
}
